﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_RowLayoutsDisplayCellIfItHasContent
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetUpGridDataSource();
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var band = e.Layout.Bands[0];
            var columns = band.Columns;

            band.RowLayoutStyle = RowLayoutStyle.ColumnLayout;

            foreach (var column in columns)
            {
                if (column.Key != "Comment")
                {
                    column.RowLayoutColumnInfo.OriginY = 1;
                    column.RowLayoutColumnInfo.SpanX = 1;
                    column.RowLayoutColumnInfo.SpanY = 1;
                }
                else
                {
                    column.RowLayoutColumnInfo.OriginY =2;
                    column.RowLayoutColumnInfo.SpanY = 1;
                    column.RowLayoutColumnInfo.SpanX = 3;
                }
            }

            e.Layout.Override.MinRowHeight = 1;
            e.Layout.Override.RowSizing = RowSizing.Free;
        }

        private void SetUpGridDataSource()
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Column 1", typeof(string)).DefaultValue = "Column 1 Value";
            dt.Columns.Add("Column 2", typeof(string)).DefaultValue = "Column 2 Value";
            dt.Columns.Add("Column 3", typeof(string)).DefaultValue = "Column 3 Value";
            dt.Columns.Add("Comment", typeof(string));

            dt.Rows.Add();
            dt.Rows.Add(new object[] { null, null, null, "This cell has comment" });

            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            var cell = e.Row.Cells["Comment"];

            if (String.IsNullOrEmpty(cell.Text))
            {
                e.Row.Height /= 2;
            }
        }

    }
}
